balaipengobatan/urls.py
from django.urls import path, include
from .views import createbp, listbp, deletebp, updatebp

app_name = "bp"
urlpatterns = [
    path('createbp', createbp, name="createbp"),
    path('listbp', listbp, name="listbp"),
    path('deletebp/<id>/', deletebp, name="deletebp"),
    path('updatebp/<id>/', updatebp, name="updatebp")
]

farmakami/urls.py
from django.contrib import admin
from django.urls import path,include
from login.views import welcome

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', welcome, name="homepage"),
    path('login/', include(('login.urls', 'login'), namespace='login')),
    path('bp/', include(('balaipengobatan.urls', 'bp'), namespace='bp')),
    path('obat/', include(('obat.urls', 'obat'), namespace='obat')),
    path('am/', include(('alat_medis.urls', 'am'), namespace='am')),
    path('transaksipembelian/', include(('transaksipembelian.urls', 'tp'), namespace='transaksipembelian')),
    path('list_produk_dibeli/', include(('list_produk_dibeli.urls', 'list_produk_dibeli'), namespace='list_produk_dibeli')),
    path('pengantaranfarmasi/', include(('pengantaranfarmasi.urls', 'pengantaranfarmasi'), namespace='pengantaranfarmasi')),
    path('Apotek/', include(('Apotek.urls', 'Apotek'), namespace='Apotek')),
    path('produkapotek/', include(('produkapotek.urls', 'produkapotek'), namespace='produkapotek')),
    path('transaksi_resep/', include(('transaksi_resep.urls', 'transaksi_resep'), namespace='transaksi_resep'))
]

login/urls.py
from django.urls import path, include
from .views import login, register_admin, register_konsumen, register_kurir, register_cs, validate, regchoice, homepage, alamat, hpalamat, logout, profile

app_name = "login"
urlpatterns = [
    path('login', login, name="login"),
    path('regadmin', register_admin, name="regadmin"),
    path('regkonsumen', register_konsumen, name="regkonsumen"),
    path('regkurir', register_kurir, name="regkurir"),
    path('regcs', register_cs, name="regcs"),
    path('regchoice', regchoice, name="regchoice"),
    path('homepage', homepage, name="homepage"),
    path('alamat/<id>/', alamat, name='alamat'),
    path('hpalamat/<id>/', hpalamat, name='hpalamat'),
    path('logout', logout, name='logout'),
    path('profile', profile, name='profile')
    # path('submitalamat/<id>/', submitalamat, name='submitalamat')
]

obat/urls.py
from django.urls import path, include
from .views import createobat, listobat, deleteobat, updateobat

app_name = "obat"
urlpatterns = [
    path('createobat', createobat, name="createobat"),
    path('listobat', listobat, name="listobat"),
    path('deleteobat/<id>/', deleteobat, name="deleteobat"),
    path('updateobat/<id>/', updateobat, name="updateobat")
]

balaipengobatan/models.py
from django.db import models

# Create your models here.

balaipengobatan/forms.py
from django import forms

class BPForm(forms.Form):
    alamat_balai = forms.CharField(label='Alamat Balai', max_length=100)
    nama_balai = forms.CharField(label='Nama Balai', max_length=50)
    jenis_balai = forms.CharField(label='Jenis Balai', max_length=30)
    telepon_balai = forms.CharField(label='Telepon Balai', max_length=20)

class BPFormEdit(forms.Form):
    alamat_balai = forms.CharField(label='Alamat Balai', max_length=100, required=False)
    nama_balai = forms.CharField(label='Nama Balai', max_length=50, required=False)
    jenis_balai = forms.CharField(label='Jenis Balai', max_length=3, required=False)
    telepon_balai = forms.CharField(label='Telepon Balai', max_length=20, required=False)
    

balaipengobatan/views.py
from django.shortcuts import render, reverse, redirect
from django.contrib.auth.models import User, Permission
from django.contrib.auth import update_session_auth_hash
from django.contrib.auth.decorators import login_required
from django.http import HttpResponseRedirect
from django.urls import reverse
from django.contrib.auth import authenticate, logout, login
from django.conf.urls.static import static
from .forms import BPForm, BPFormEdit
import pandas as pd
from django_tables2.tables import Table
from django.contrib.staticfiles import finders
from django.contrib.staticfiles.storage import staticfiles_storage
from farmakami.settings import STATIC_DIR
from django.db import connection
from collections import namedtuple
import os

def namedtuplefetchall(cursor):
    "Return all rows from a cursor as a namedtuple"
    desc = cursor.description
    nt_result = namedtuple('Result', [col[0] for col in desc])
    return [nt_result(*row) for row in cursor.fetchall()]


def createbp(request):
    try:
        role = request.session['role']
    except:
        return redirect("/")
    
    if role != 'admin_apotek':
        return redirect("/")

    if request.method =='POST':
        alamat_balai = request.POST.get("alamat_balai")
        nama_balai = request.POST.get("nama_balai")
        jenis_balai = request.POST.get("jenis_balai")
        telepon_balai = request.POST.get("telepon_balai")

        cursor = connection.cursor()

        sumid = "select count(*) from farmakami.balai_pengobatan"
        cursor.execute(sumid)
        sumidfix = cursor.fetchone()[0]
        sql_last_id = "select id_balai from farmakami.balai_pengobatan limit " + str(sumidfix) + " offset " + str((sumidfix-1)) + ""
        cursor.execute(sql_last_id)
        last_id = cursor.fetchone()
        last_id = int(last_id[0][2:])
        last_id = last_id + 1
        fix_id = "BP" + str(last_id)

        #Mencari ID
        sumid = "select count(*) from farmakami.balai_pengobatan"
        cursor.execute(sumid)
        sumidfix = cursor.fetchone()[0]

        test = "BP" + str(sumidfix)
        sql_test = "select count(*) from farmakami.balai_pengobatan where id_balai ='" + test + "'"
        cursor.execute(sql_test)
        hasil = cursor.fetchone()[0]

        while(hasil != 0):
            sumidfix = sumidfix + 1
            test = "BP" + str(sumidfix)
            sql_test = "select count(*) from farmakami.balai_pengobatan where id_balai ='" + test + "'"
            cursor.execute(sql_test)
            hasil = cursor.fetchone()[0]

        fix_id = "BP" + str(sumidfix)
        #Sampe sini
        
        sql_bp = "insert into farmakami.balai_pengobatan VALUES (%s, %s, %s, %s, %s);"
        cursor.execute(sql_bp,(fix_id, alamat_balai, nama_balai, jenis_balai, telepon_balai))

        return redirect('/bp/listbp')
    form = BPForm()
    args = {'form': form}
    cursor.close()
    return render(request, 'createbp.html', args)

def listbp(request):
    dataset = []
    cursor = connection.cursor()
    sql_all_bp= "select * from farmakami.read_bp"
    cursor.execute(sql_all_bp)
    dataset = namedtuplefetchall(cursor)
    table = []
    for t in dataset:
        temp = t.asosiasi.split(",")
        table.append({'row': t, 'asosiasi':temp})
    context = {'table': table}
    cursor.close()
    return render(request, "listbp.html", context)

def deletebp(request, id):
    try:
        role = request.session['role']
    except:
        return redirect("/")
    
    if role != 'admin_apotek':
        return redirect("/")

    cursor = connection.cursor()
    sql_delete_bp= "delete from farmakami.balai_pengobatan where id_balai = '" +  id + "'"
    cursor.execute(sql_delete_bp)
    cursor.close()
    return redirect('/bp/listbp')

def updatebp(request, id):
    try:
        role = request.session['role']
    except:
        return redirect("/")
    
    if role != 'admin_apotek':
        return redirect("/")

    if request.method == "POST":
        alamat_balai = request.POST.get("alamat_balai")
        nama_balai = request.POST.get("nama_balai")
        jenis_balai = request.POST.get("jenis_balai")
        telepon_balai = request.POST.get("telepon_balai")
        apotek = request.POST["id_apotek_select"]
        print("haha")
        print(alamat_balai)

        cursor = connection.cursor()

        if alamat_balai != "":
            sql = "update farmakami.balai_pengobatan set alamat_balai ='" + alamat_balai +"' where id_balai ='" + id + "';"
            cursor.execute(sql)

        if nama_balai != "":
            sql = "update farmakami.balai_pengobatan set nama_balai ='" + nama_balai +"' where id_balai ='" + id + "';"
            cursor.execute(sql)
        
        if jenis_balai != "":
            sql = "update farmakami.balai_pengobatan set jenis_balai ='" + jenis_balai +"' where id_balai ='" + id + "';"
            cursor.execute(sql)
        
        if jenis_balai != "":
            sql = "update farmakami.balai_pengobatan set jenis_balai ='" + jenis_balai +"' where id_balai ='" + id + "';"
            cursor.execute(sql)
        
        if telepon_balai != "":
            sql = "update farmakami.balai_pengobatan set telepon_balai ='" + telepon_balai +"' where id_balai ='" + id + "';"
            cursor.execute(sql)
        
        if apotek != "none":
            check = "select count(*) from farmakami.balai_apotek where id_balai ='" + id + "' and id_apotek = '" + apotek +"'"
            cursor.execute(check)
            checknum = cursor.fetchone()[0]
            if checknum == 0:
                sql = "insert into farmakami.balai_apotek values(%s,%s)"
                cursor.execute(sql, (id, apotek))
        
        return redirect('/bp/listbp')
    print(id)
    cursor = connection.cursor()
    sql_apotek = "select id_apotek from farmakami.apotek"
    cursor.execute(sql_apotek)
    apotek = namedtuplefetchall(cursor)
    form = BPFormEdit()
    args = {'form': form, "apotek":apotek, "id":id }
    cursor.close()
    return render(request, "updatebp.html", args)

balaipengobatan/templates/base.html
<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>FarmaKami</title>
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css"
        integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.11.2/css/all.min.css">
</head>

<body>
    <div class="jumbotron m-5">
        {% block content %}
        {% endblock content %}
    </div>
    
    <br><br>
    <hr class="my-4">

    <a href="{% url 'login:homepage' %}" class="btn btn-outline-primary" role="button">Homepage</a>
    <a href="{% url 'login:logout' %}" class="btn btn-outline-primary" role="button">Logout</a>


    <script src="https://code.jquery.com/jquery-3.3.1.slim.min.js"
        integrity="sha384-q8i/X+965DzO0rT7abK41JStQIAqVgRVzpbzo5smXKp4YfRvH+8abtTE1Pi6jizo"
        crossorigin="anonymous"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.7/umd/popper.min.js"
        integrity="sha384-UO2eT0CpHqdSJQ6hJty5KVphtPhzWj9WO1clHTMGa3JDZwrnQq4sF86dIHNDz0W1"
        crossorigin="anonymous"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.min.js"
        integrity="sha384-JjSmVgyd0p3pXB1rRibZUAYoIIy6OrQ6VrjIEaFf/nJGzIxFDsf4x0xIM+B07jRM"
        crossorigin="anonymous"></script>
</body>

</html>

balaipengobatan/templates/createbp.html
{% extends "base.html" %}

{% block content %}

<h1 class="display-4">Create Balai Pengobatan</h1>
<p class="lead font-italic">FarmaKami Indonesia</p>
<hr class="my-4">

<style>
    input, select {
        display: block;
        width: 50%;
        height: 34px;
        padding: 6px 12px;
        font-size: 14px;
        line-height: 1.42857143;
        color: #555;
        background-color: #fff;
        background-image: none;
        border: 1px solid #ccc;
        border-radius: 4px;
        -webkit-box-shadow: inset 0 1px 1px rgba(0,0,0,.075);
        box-shadow: inset 0 1px 1px rgba(0,0,0,.075);
        -webkit-transition: border-color ease-in-out .15s,box-shadow ease-in-out .15s;
        -o-transition: border-color ease-in-out .15s,box-shadow ease-in-out .15s;
        -webkit-transition: border-color ease-in-out .15s,-webkit-box-shadow ease-in-out .15s;
        transition: border-color ease-in-out .15s,-webkit-box-shadow ease-in-out .15s;
        transition: border-color ease-in-out .15s,box-shadow ease-in-out .15s;
        transition: border-color ease-in-out .15s,box-shadow ease-in-out .15s,-webkit-box-shadow ease-in-out .15s;
    }
</style>

<div class="container">         
    <form method="post">
        {% csrf_token %}
        {{ form.as_p }}
        <button class="btn btn-outline-primary" type="submit">Submit</button>
    </form>
</div>

{% endblock content %}

balaipengobatan/templates/listbp.html
{% extends "base.html" %}


{% block content %}

<h1 class="display-4">List Balai Pengobatan</h1>
<p class="lead font-italic">FarmaKami Indonesia</p>
<hr class="my-4">

<table class="table table-striped table table-hover">
    <thead>
      <tr>
        <th scope="col">Id Balai</th>
        <th scope="col">Alamat Balai</th>
        <th scope="col">Nama Balai</th>
        <th scope="col">Jenis Balai</th>
        <th scope="col">Telepon Balai</th>
        <th scope="col">Apotek Asosiasi</th>
        <th scope="col">Edit</th>
        <th scope="col">Delete</th>
      </tr>
    </thead>
    <tbody>
    {% for item in table %}
      <tr>
        <td>{{ item.row.id_balai }}</td>
        <td>{{ item.row.alamat_balai }}</td>
        <td>{{ item.row.nama_balai }}</td>
        <td>{{ item.row.jenis_balai }}</td>
        <td>{{ item.row.telepon_balai }}</td>
        <td>
          {% for apotek in item.asosiasi %}
          <t>• {{ apotek }}</t><br>
          {% endfor %}
        
        </td>
        <td><a href="{% url 'bp:updatebp' item.row.id_balai %}" class="btn btn-outline-primary" role="button">Edit</a></td>
        <td><a href="{% url 'bp:deletebp' item.row.id_balai %}" class="btn btn-outline-primary" role="button">Delete</a></td>
      </tr>
      {% endfor %}
    </tbody>
  </table>



{% endblock content %}

balaipengobatan/templates/updatebp.html
{% extends "base.html" %}

{% block header %}
<!-- <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.4.1/jquery.min.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
<script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.4.1/js/bootstrap.min.js"></script> -->

{% endblock header %}

{% block content %}

<style>
    input, select {
        display: block;
        width: 50%;
        height: 34px;
        padding: 6px 12px;
        font-size: 14px;
        line-height: 1.42857143;
        color: #555;
        background-color: #fff;
        background-image: none;
        border: 1px solid #ccc;
        border-radius: 4px;
        -webkit-box-shadow: inset 0 1px 1px rgba(0,0,0,.075);
        box-shadow: inset 0 1px 1px rgba(0,0,0,.075);
        -webkit-transition: border-color ease-in-out .15s,box-shadow ease-in-out .15s;
        -o-transition: border-color ease-in-out .15s,box-shadow ease-in-out .15s;
        -webkit-transition: border-color ease-in-out .15s,-webkit-box-shadow ease-in-out .15s;
        transition: border-color ease-in-out .15s,-webkit-box-shadow ease-in-out .15s;
        transition: border-color ease-in-out .15s,box-shadow ease-in-out .15s;
        transition: border-color ease-in-out .15s,box-shadow ease-in-out .15s,-webkit-box-shadow ease-in-out .15s;
    }
</style>

<h1 class="display-4">Edit Balai Apotek {{ id }}</h1>
<p class="lead font-italic">FarmaKami Indonesia</p>
<hr class="my-4">

<div class="container">  
    
    <label>ID Balai: </label>  
    <input type="text" name="id_balai" id="id_balai" value = {{ id }} disabled> 
    <br>
    
    <form method="post">
        {% csrf_token %}
        {{ form.as_p }}
        <br>

        <label for="id_apotek">ID Apotek:</label>

        <select id="id_apotek_select" name="id_apotek_select">
            <option value="none">none</option>
            {% for ap in apotek %}
               <option value={{ap.id_apotek}}>{{ap.id_apotek}}</option>
            {% endfor %}
        </select>

        <br>

        <button class="btn btn-outline-primary" type="submit">Submit</button>
    </form>
</div>

{% endblock content %}